<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>

<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>

<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>
<%@ page import="java.text.SimpleDateFormat" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<%
    DSSession dsSession = (DSSession)request.getAttribute("DSSession");
    java.util.Locale locale = dsSession.getLocale();
%>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% dsrouting.setDSSession(request); 
String keySuffix = dsrouting.getDateKeySuffix(); //AR8506+: after dsrouting.setDSSession(request)
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
%>

<TABLE class="colltable" style="margin-top:10px">
<col class="col_actions" />
<col class="col_actions" />

<tr>
<th class="icon">&nbsp;</th>
<th class="name"><%= MessageDB.get("Name", locale) %></th>
<th><%= MessageDB.get("form.owner", locale) %></th>
<th><%= MessageDB.get("Status", locale) %></th>
<th><%= MessageDB.get("date_label", locale) %></th>
</tr>

<%
    DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();

    String document = request.getParameter("document");
    if (document == null) {
        out.println("<h3>" + MessageDB.get("routing_error_no_doc_specified", locale) + "</h3>");
        return;
    }
    
    int[] workFlowJobsForDocument = dsrouting.getWorkFlowJobsForDocument(document);
    if ((workFlowJobsForDocument == null) || (workFlowJobsForDocument.length == 0)) {
%>
<tr>
<td> </td>
<td class="name">
<%= MessageDB.get("routing_no_assigned_tasks_to_doc", locale) %>
</td>
</tr>
<%
    } else {
        Date nowDate = new Date();
        for (int i = 0; i < workFlowJobsForDocument.length; i++) {
            String subject = dsrouting.getSubject(workFlowJobsForDocument[i]);
    
            String routingStatus = dsrouting.getRoutingStatus(workFlowJobsForDocument[i]);
            routingStatus = dsrouting.getLocalizedStatus(routingStatus, locale);
            Date creationDate = dsrouting.getWorkFlowJobCreationTime(workFlowJobsForDocument[i]);
            String dateStr = new SimpleDateFormat(MessageDB.get("date_short_2"+keySuffix, locale)).format(creationDate); //AR8506+
            // get the owner name
            String owner = dsrouting.getWorkFlowOwner(workFlowJobsForDocument[i]);
            String ownerName = owner;
            try {
                DSUser dsOwner = (DSUser)dsSession.getObject(new DSHandle(owner), DSSelectSet.NO_PROPERTIES); //AR13400
                //AR 3393 :display full user name                    
                ownerName = dsOwner.getUserName();
                //ownerName = GenericUtil.getLongName(dsOwner, dsSession);
            } catch (Exception ex) {
            }
    
            // get action from routing slip
            String workFlowAction = dsrouting.getWorkFlowAction(workFlowJobsForDocument[i]);
    
            // use workflow action (e.g. ForReview, ForApproval) as the target for the Report URL
            //AR6223-: String reportUrlStr = workFlowAction + "Report.jsp" + "?workFlowJobName=" + workFlowJobsForDocument[i];
            String reportUrlStr = "report_base.jsp?reportType="+ workFlowAction + "Report&workFlowJobName=" + workFlowJobsForDocument[i]; //AR6223+

            // use the first document title as the subject if no subject specified
            if (subject.length() == 0) {
                String doc = (String) dsrouting.getDocuments(workFlowJobsForDocument[i]).iterator().next();
                DSHandle dsHandle = new DSHandle(doc);
                DSObject dsObj = dsSession.getObject(dsHandle, DSSelectSet.NO_PROPERTIES); //AR13400
                if (dsObj instanceof DSVersion) {
                    // get document from version
                    dsObj = ((DSVersion)dsObj).getDocument(DSSelectSet.NO_PROPERTIES);
                }
                // use the first document as the subject if no subject given
                subject = "re: " + ((DSDocument)dsObj).getTitle();
            }
            subject = AmberUtility.xss_safe_value(subject);
%>
<tr>
<td><img alt='<%= MessageDB.get("task_icon", locale) %>' title='<%= MessageDB.get("task_icon", locale) %>' src="images/action_routing.gif" /></td>
<td class="name">
<a class="uline" href="javascript:openTaskWindow('<%= reportUrlStr %>')"><%= (subject.length() == 0) ? "- &nbsp;"  : subject %></a>
<%
            Date dueDate = dsrouting.getWorkFlowByDate(workFlowJobsForDocument[i]);
            if ((dueDate != null) && !dueDate.after(nowDate)) {
                String jobStatus =  dsrouting.getRoutingStatus(workFlowJobsForDocument[i]);
                if (dsrouting.isJobRunning(workFlowJobsForDocument[i])) {
%>
<font color='red'><strong>&nbsp;(<%= MessageDB.get("routing_overdue", locale) %>)</strong></font>
<%              }
            }
%>
</td>
<td class="generic" >
<%= ownerName %>
</td>
<td class="generic" >
<%= routingStatus %>
</td>
<td class="lightem" >
<%= dateStr %>
</td>
</tr>
<%      }
    }
%>
</table>
