<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="com.xerox.docushare.routing.*" %>
<%@ page import="com.xerox.docushare.workflow.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
  <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>

<% dsrouting.setDSSession(request); 
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
final DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
final String loginUser = dsUser.getHandle().toString();
String all_comments = MessageDB.get("routing_show_all_comments", locale);
%>

 <HEAD> 
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
   <%@ include file="ThemeUtil.jsp" %>

<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>

	<title><%= MessageDB.get("routing_show_all_comments", locale) %> </title>
 </HEAD> 
<body>
  <div id="header">
    <h1>DocuShare</h1>
    <h2><%= all_comments %></h2>
    <div id="header-wrapper">
        <p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p>
    </div>
  </div>
	<div id="content">
	<h2><%= all_comments %></h2>
	<p class="note"><strong><%=MessageDB.get("routing_note", locale)%>:</strong>
<%
String browserType = (String)browserInfo.getProperty("browserType");
if ("Netscape".equals(browserType) || "Mozilla".equals(browserType))
  out.println(MessageDB.get("routing_ns_save_comments", locale));
else
  out.println(MessageDB.get("routing_ie_save_comments", locale));
%>
	</p>
	<ul id="commentlist">
<%
int iCommentCount = 0;
int routingSlip = 0;
try{
  routingSlip = Integer.parseInt(request.getParameter("routingSlip"));
}catch(Exception e) { System.out.println("savecomment.jsp parseInt: "+e); }

HashMap routingMap = dsrouting.getRoutingInfo(routingSlip);
String owner = (String)routingMap.get("Owner"); 
for (Iterator recipientItr = ((ArrayList)routingMap.get("TaskID_Recipients")).iterator(); recipientItr.hasNext(); ) {
  String tid_rec = (String)recipientItr.next(); //format: "tid_uid: Review (1.2)"
  String step = "";
  try{ step = tid_rec.substring(tid_rec.indexOf('(')+1, tid_rec.indexOf('.'));
  }catch(Exception estep) {}
  tid_rec = tid_rec.substring(0, tid_rec.indexOf(':'));
  String aRecipient = tid_rec.substring(tid_rec.indexOf('_')+1);
  String aTask = tid_rec.substring(0, tid_rec.indexOf('_'));
  
  String aRecipientName = dsrouting.getUserFullName(aRecipient);
  if(aRecipientName.startsWith("routing_")) //routing_deleted, routing_no_access
    aRecipientName = aRecipient + " ("+ MessageDB.get(aRecipientName, locale)+")";
  /* Singapore team AR5316 SPAR C20597 - User full names (firstname/lastname) with double quotes crush add user to routing slip */
  String commentLabel = dsrouting.parseDoubleQuote(aRecipientName) + " " + MessageDB.get("comment_label", locale) + ": <br>";

  if(routingMap.get(tid_rec+"_StatusTime")==null) 
    continue; //AR8368 skip "Respond Later" comments
  String comments = (String)routingMap.get(tid_rec+"_Comment");  
  if(comments != null && comments.length() > 0){
    if(routingMap.get(tid_rec+"_PrivateComment") != null) {//private comment
      //further check user with routingslip owner and comment owner:
      if(!loginUser.equals(aRecipient) && !loginUser.equals(owner))
        comments = MessageDB.get("routing_private_comments", locale);
    }
    //replace new line with <br>:
    String sTmp = "";
    BufferedReader reader = new BufferedReader(new StringReader(comments));
    while (true) {
      String line = reader.readLine();
      if(line == null) break;
      sTmp += line + "<br>";
    }
    comments = sTmp;
  
    // AR4672 we need filter Control character from comments
    comments = comments.replace('"','\'');
    char[] chararray = comments.toCharArray();
    for (int j = 0; j < chararray.length; j++) {
        if (Character.isISOControl(chararray[j]))
            chararray[j] = Character.SPACE_SEPARATOR;
    }
    comments = new String(chararray);
    iCommentCount++;
    %>
		<li>
			<cite><%= commentLabel %></cite> 
			<blockquote>
				<p><%= AmberUtility.xss_safe_value(comments) %></p>
			</blockquote>
		</li>
    <%
  }
}
%>
    </ul>
    </div>
</body>
</html>
